/**************************************************************************************************

(c) 2006, Sharath C

See license.txt for details.

This program is distributed under the terms of the GPL v2.

		    GNU GENERAL PUBLIC LICENSE
		       Version 2, June 1991

***************************************************************************************************/

/**************************************************************************************************

This program is a small helper (hopefully) utility to change the FourCC code inside
AVI file format.

***************************************************************************************************/

#include <stdio.h>
#include <gtk/gtk.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <asm/fcntl.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

GtkWidget *Mainwin;
GtkWidget *Fixed;
GtkWidget *Label1, *Label2, *Label3;
GtkWidget *Entry2;
GtkWidget *Save, *Quit;
int fd;

void ReadFourCC(char *filename)
{
	char buf[4];

	lseek(fd, 112, SEEK_SET);
	read(fd, buf, 4);

	Label3=gtk_label_new(buf);
	gtk_fixed_put(GTK_FIXED(Fixed), GTK_WIDGET(Label3), 120, 20);
	gtk_widget_show(Label3);
	gtk_widget_grab_focus(GTK_WIDGET(Entry2));
}

void WriteFourCC(char *filename)
{
	G_CONST_RETURN gchar *fourcc;
	GtkWidget *Done;

	fourcc=gtk_entry_get_text(GTK_ENTRY(Entry2));
	if((strlen(fourcc)) != 4) {
		Done=gtk_message_dialog_new(	GTK_WINDOW(Mainwin),
						GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
						GTK_MESSAGE_ERROR,
						GTK_BUTTONS_OK,
						"Incorrect FourCC !");
		gtk_dialog_run(GTK_DIALOG(Done));
		gtk_widget_destroy(Done);
		return;
	}

	lseek(fd, 112, SEEK_SET);
	write(fd, fourcc, 4);

	lseek(fd, 188, SEEK_SET);
	write(fd, fourcc, 4);

	Done=gtk_message_dialog_new(	GTK_WINDOW(Mainwin),
					GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
					GTK_MESSAGE_INFO,
					GTK_BUTTONS_OK,
					"FourCC successfully changed !");

	gtk_dialog_run(GTK_DIALOG(Done));
	gtk_widget_destroy(Done);
	gtk_main_quit();
}

int main(int argc, char *argv[])
{
	int i;

	if(argc == 1 || argc >= 3) {
		printf("%s - incorrect number of arguments.\nTry %s [filename.avi]\n", argv[0], argv[0]);
		exit(-1);
	}

	gtk_init(&argc, &argv);

	Mainwin=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	g_signal_connect(G_OBJECT(Mainwin), "delete-event", G_CALLBACK(gtk_main_quit), NULL);
	gtk_window_set_default_size(GTK_WINDOW(Mainwin), 200, 150);
	gtk_window_set_position(GTK_WINDOW(Mainwin), GTK_WIN_POS_CENTER_ALWAYS);
	gtk_window_set_title(GTK_WINDOW(Mainwin), "FourCC Changer");

	Fixed=gtk_fixed_new();
	gtk_container_add(GTK_CONTAINER(Mainwin), GTK_WIDGET(Fixed));

	Label1=gtk_label_new("Current FourCC :");
	gtk_fixed_put(GTK_FIXED(Fixed), GTK_WIDGET(Label1), 10, 20);

	Label2=gtk_label_new("Enter FourCC :");
	gtk_fixed_put(GTK_FIXED(Fixed), GTK_WIDGET(Label2), 22, 60);

	Entry2=gtk_entry_new_with_max_length(4);
	gtk_fixed_put(GTK_FIXED(Fixed), GTK_WIDGET(Entry2), 120, 50);
	gtk_widget_set_size_request(GTK_WIDGET(Entry2), 50, 30);

	Save=gtk_button_new_from_stock(GTK_STOCK_SAVE);
	g_signal_connect(G_OBJECT(Save), "clicked", G_CALLBACK(WriteFourCC), NULL);
	gtk_fixed_put(GTK_FIXED(Fixed), GTK_WIDGET(Save), 20, 110);

	Quit=gtk_button_new_from_stock(GTK_STOCK_QUIT);	
	g_signal_connect(G_OBJECT(Quit), "clicked", G_CALLBACK(gtk_main_quit), NULL);
	gtk_fixed_put(GTK_FIXED(Fixed), GTK_WIDGET(Quit), 120, 110);

	gtk_widget_show(Mainwin);
	gtk_widget_show(Fixed);
	gtk_widget_show(Label1);
	gtk_widget_show(Label2);

	gtk_widget_show(Entry2);
	gtk_widget_show(Save);
	gtk_widget_show(Quit);

	fd=open(argv[1], O_RDWR | O_LARGEFILE);

	ReadFourCC(argv[1]);

	gtk_main();

	return 0;
}

